unit Global;

interface

{$DEFINE VESA}

const
  MaxX = 640;					{ ࠧ襭  ਧ⠫ }
  MaxY = 480;					{ ࠧ襭  ⨪ }
  NumPal = 256 * 3 - 1;


type
  Line = array[0..MaxX] of byte;
  PLine = ^Line;
  BlockPal = array[0..NumPal] of byte;
  PBlockPal = ^BlockPal;

function GetPixel( X, Y: word ): byte;
{inline( $5A/		{ pop dx }
{	$59/		{ pop cx }
{	$B4/$0D/	{ mov ah,0Dh }
{	$B7/$00/	{ mov bh,0 }
{	$CD/$10 );	{ int 10h }

procedure SetPixel( X, Y: word; Color: byte );
{inline( $58/		{ pop ax }
{	$5A/		{ pop dx }
{	$59/		{ pop cx }
{	$B4/$0C/	{ mov ah,0Ch }
{	$B7/$00/	{ mov bh,0 }
{	$CD/$10 );	{ int 10h }

procedure GetPalette( Buffer: PBlockPal );

procedure SetPalette( BufPal: pointer );

procedure SetAllPalette( Buffer: PBlockPal );

procedure GetLine( Buffer: PLine; NumLine: word );

procedure SetLine( Buffer: PLine; NumLine: word );


implementation

procedure SetPixel; assembler;			{ ᮢ 窨 }
asm
  mov	ax,MaxX
  mul	Y
  add	ax,X
  mov	di,ax
{$IFNDEF VGA}
  adc	dl,0
  mov	ah,dl
{$ENDIF}
{$IFDEF CIRRUS}
  shl	ah,4
  mov	al,9
  mov	dx,$3CE
  out	dx,ax
{$ENDIF}
{$IFDEF VESA}
  mov	ax,$4F05
  push	ax
  push	dx
  xor	bx,bx
  int	10h
  pop	dx
  pop	ax
  inc	bx
  int	10h
{$ENDIF}
  mov	ax,$A000
  mov	es,ax
  mov	al,Color
  stosb
end;

function GetPixel; assembler;			{ 祭 梥 窨 }
asm
  mov	ax,MaxX
  mul	Y
  add	ax,X
  mov	di,ax
{$IFNDEF VGA}
  adc	dl,0
  mov	ah,dl
{$ENDIF}
{$IFDEF CIRRUS}
  shl	ah,4
  mov	al,9
  mov	dx,$3CE
  out	dx,ax
{$ENDIF}
{$IFDEF VESA}
  mov	ax,$4F05
  push	ax
  push	dx
  xor	bx,bx
  int	10h
  pop	dx
  pop	ax
  inc	bx
  int	10h
{$ENDIF}
  mov	ax,$A000
  mov	es,ax
  mov	al,es:[di]
end;

procedure GetPalette; assembler;		{ 祭 ⥪饩  }
asm
  mov	ax,1017h
  les	dx,Buffer
  mov	bx,0
  mov	cx,256
  int	10h
end;

procedure SetPalette; assembler;		{ ⠭  }
asm
  mov	si,word ptr BufPal
  mov	bx,0
  mov	dh,63
  mov	ch,dh
  mov	cl,dh
  mov	ax,1010h
  int	10h
@1:
  mov	dl,[si]
@2:
  add	dh,[si+1]
  add	ch,[si+2]
  add	cl,[si+3]
  inc	bx
  mov	ax,1010h
  int	10h
  dec	dl
  jnz @2
  add	si,4
  cmp	byte ptr [si],0
  jne @1
end;

procedure SetAllPalette; assembler;
asm
  les	dx,Buffer
  mov	ax,1012h
  mov	bx,0
  mov	cx,256
  int	10h
end;

procedure GetLine;
var
  Cnt: word;
begin
  for Cnt := 0 to MaxX - 1 do Buffer^[Cnt] := GetPixel( Cnt, NumLine )
end;

procedure SetLine;
var
  Cnt: word;
begin
  for Cnt := 0 to MaxX - 1 do SetPixel( Cnt, NumLine, Buffer^[Cnt] )
end;

end.